import 'dart:async';

import 'package:flutter/material.dart';
import 'package:payment_gateway/constants/merchant_constants.dart';
import 'package:payment_gateway/logic/safex_pay_bloc.dart';
import 'package:payment_gateway/observer/safexpay_observable.dart';
import 'package:payment_gateway/utils/crypto_utils.dart';
import 'package:payment_gateway/utils/shared_preference_utils.dart';
import 'package:shared_preferences/shared_preferences.dart';

import 'constants/constants.dart';
import 'make_payment_webview.dart';

class NetBanking extends StatefulWidget {
  static const String routeName = "/NetBanking";
  final SafeXPayBloc safeXPayBloc;

  NetBanking({Key? key, required this.safeXPayBloc}) : super(key: key);

  @override
  _MyHomePageState createState() => new _MyHomePageState();
}

class _MyHomePageState extends State<NetBanking> {
  TextEditingController editingController = TextEditingController();
  Timer? searchOnStoppedTyping;

  List<String>? _bankNameList;
  List<String>? _filterSearchList;
  String bankName = "Bank Name";

  @override
  void initState() {
    super.initState();
    _generateStaticBankList();
  }

  @override
  void dispose() {
    super.dispose();
  }

  void _generateStaticBankList() {
    _bankNameList = <String>[];
    _bankNameList = [
      "Demo Bank",
      "ICICI Bank",
      "HDFC Bank",
      "Kotak Bank",
      "Federal Bank",
      "Corporation Bank",
      "Yes Bank",
      "Vijaya Bank"
    ];
    _bankNameList!.sort();
    _filterSearchList = <String>[];
    _filterSearchList!.addAll(_bankNameList!);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      backgroundColor: Colors.white,
      body: SingleChildScrollView(child: _buildWidget()),
    );
  }

  Widget _buildWidget() {
    return Padding(
      padding: const EdgeInsets.symmetric(vertical: 4.0, horizontal: 12),
      child: Column(crossAxisAlignment: CrossAxisAlignment.start, children: [
        Padding(
          padding: const EdgeInsets.symmetric(vertical: 2),
          child: Row(
            children: [
              IconButton(
                onPressed: () {
                  // Navigator.of(context).pop();
                  final SafeXPayObservable safeXPayObservable =
                      SafeXPayObservable();
                  safeXPayObservable.notifyOnIndexChanged(1);
                },
                icon: Icon(
                  Icons.arrow_back_ios,
                  color: Colors.grey,
                ),
              ),
              Text(
                'BACK TO PAYMENT METHODS',
                style: const TextStyle(
                    color: Colors.grey,
                    fontStyle: FontStyle.normal,
                    fontSize: 16.0),
              ),
            ],
          ),
        ),
        // AppHeader(),
        // SizedBox(height: 50),
        GridView.count(
          primary: false,
          // padding: const EdgeInsets.all(20),
          crossAxisSpacing: 10,
          mainAxisSpacing: 10,
          crossAxisCount: 3,
          shrinkWrap: true,
          physics: NeverScrollableScrollPhysics(),
          children: <Widget>[
            getCardView('packages/payment_gateway/img/SBI.png', 'SBI'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/SBI.png',
                          height: (MediaQuery.of(context).size.width) / 5.8,//55,
                          width: (MediaQuery.of(context).size.width) / 5.8,//55,
                          // width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'SBI',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
            getCardView('packages/payment_gateway/img/Yes.png', 'Yes'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/Yes.png',
                          height: 55,
                          width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'Yes',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
            getCardView('packages/payment_gateway/img/Axis.png', 'Axis'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/Axis.png',
                          height: 55,
                          width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'Axis',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
            getCardView('packages/payment_gateway/img/Kotak.png', 'Kotak'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/Kotak.png',
                          height: 55,
                          width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'Kotak',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
            getCardView('packages/payment_gateway/img/Hdfc.png', 'HDFC'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/Hdfc.png',
                          height: 55,
                          width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'HDFC',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
            getCardView('packages/payment_gateway/img/ICICI.png', 'ICICI'),
            /*Container(
                    decoration: BoxDecoration(
                      border: Border.all(
                        color: Colors.grey,
                        width: 1,
                      ),
                      borderRadius: BorderRadius.circular(8.0),
                    ),
                    padding: const EdgeInsets.all(8),
                    child: Column(
                      children: [
                        Image.asset(
                          'packages/payment_gateway/img/ICICI.png',
                          height: 55,
                          width: 55,
                        ),
                        SizedBox(height: 8),
                        Text(
                          'ICICI',
                          style: const TextStyle(
                              color: Colors.grey,
                              fontStyle: FontStyle.normal,
                              fontSize: 14.0),
                        ),
                      ],
                    )),*/
          ],
        ),
        SizedBox(height: 8),
        InkWell(
          onTap: () {
            _modalBottomSheetMenu();
          },
          child: Padding(
            padding: EdgeInsets.symmetric(vertical: 2, horizontal: 0),
            child: Container(
              padding: EdgeInsets.only(left: 10),
              height: 50,
              decoration: BoxDecoration(
                boxShadow: [
                  BoxShadow(
                      color: Colors.grey.withOpacity(0.5),
                      blurRadius: 3,
                      offset: Offset(0.0, 3)),
                ],
                color: Colors.white,
              ),
              child: Row(
                children: [
                  Container(
                    child: Expanded(
                      child: Row(
                        children: [
                          Text(
                            bankName,
                            style: TextStyle(
                                color: Colors.grey[600],
                                fontStyle: FontStyle.normal,
                                fontSize: 16.0),
                          ),
                        ],
                      ),
                    ),
                  ),
                  Icon(
                    Icons.keyboard_arrow_down,
                    color: Colors.grey[600],
                    size: 32.0,
                  ),
                ],
              ),
            ),
          ),
        ),
        /*GestureDetector(
          onTap: () {
            print("Pay Now clicked");
          },
          child: Container(
            alignment: Alignment.center,
            height: 50,
            width: MediaQuery.of(context).size.width * 0.7,
            color: Color(0xFFd9e7f7),
            margin: EdgeInsets.fromLTRB(40, 40, 40, 40),
            child: Text(
              "PAY NOW",
              style: const TextStyle(
                  color: Colors.white,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.bold,
                  fontSize: 16.0),
            ),
          ),
        ),*/
        const SizedBox(
          height: 24,
        ),
        Center(
          child: ElevatedButton(
              onPressed: () {
                proceedPayment(context);
                /*if (_formKey.currentState!.validate()) {
                    MaterialPageRoute<PaymentMode> route = MaterialPageRoute(
                      builder: (BuildContext context) => PaymentMode(),
                    );
                    Navigator.push(context, route);
                  } else {
                    setState(() {
                      autoValidate = true;
                    });
                  }*/
              },
              child: Text(
                'PAY NOW',
                style: const TextStyle(
                    color: Colors.white,
                    fontWeight: FontWeight.w500,
                    fontSize: 16.0),
              ),
              style: ElevatedButton.styleFrom(
                  primary: UIConstants.primaryColor,
                  shape: RoundedRectangleBorder(),
                  padding: const EdgeInsets.symmetric(
                      vertical: 12, horizontal: 24))),
        ),
        const SizedBox(
          height: 24,
        ),
      ]),
    );
  }

  Future<void> proceedPayment(BuildContext context) async {
    String strTransactionType = '${MerchantConstants.agId}'
        '|${MerchantConstants.merchantId}'
        '|${widget.safeXPayBloc.orderNo}'
        '|${widget.safeXPayBloc.amount}'
        '|${widget.safeXPayBloc.countryCode}'
        '|${widget.safeXPayBloc.currency}'
        '|${widget.safeXPayBloc.transactionType}'
        '|${widget.safeXPayBloc.successUrl}'
        '|${widget.safeXPayBloc.failureUrl}'
        '|${widget.safeXPayBloc.channel}';
    String? encryptedTransactionDetails =
        CryptoUtils.encrypt(strTransactionType, MerchantConstants.merchantKey);

    String strPgDetails = '1190|NB|7|7';
    String? encryptedPgDetails =
        CryptoUtils.encrypt(strPgDetails, MerchantConstants.merchantKey);

    String? encryptedCardDetails =
        CryptoUtils.encrypt('||||', MerchantConstants.merchantKey);

    final SharedPreferences preferences = await SharedPreferences.getInstance();
    String? name = preferences.getString(SharedPreferenceUtils.userName);
    String? email = preferences.getString(SharedPreferenceUtils.userEmail);
    String? mobile = preferences.getString(SharedPreferenceUtils.userMobile);

    String strUserDetails = '$name|$email|$mobile||Y';
    String? encryptedUserDetails =
        CryptoUtils.encrypt(strUserDetails, MerchantConstants.merchantKey);

    String? billDetails =
        CryptoUtils.encrypt('||||', MerchantConstants.merchantKey);
    String? shipDetails =
        CryptoUtils.encrypt('||||||', MerchantConstants.merchantKey);
    String? itemDetails =
        CryptoUtils.encrypt('||', MerchantConstants.merchantKey);
    String? otherDetails =
        CryptoUtils.encrypt('||||', MerchantConstants.merchantKey);

    /*Map<String, dynamic> jsonMap = {
      'txn_details':encryptedTransactionDetails,
      'pg_details':encryptedPgDetails,
      'card_details': encryptedCardDetails,
      'cust_details': encryptedUserDetails,
      'bill_details': billDetails,
      'ship_details': shipDetails,
      'item_details': itemDetails,
      'other_details': otherDetails,
      'me_id':MerchantConstants.merchantId
    };*/
    String? htmlContent = await widget.safeXPayBloc.makePayment(
        encryptedTransactionDetails,
        encryptedPgDetails,
        encryptedCardDetails,
        encryptedUserDetails,
        billDetails,
        shipDetails,
        itemDetails,
        otherDetails,
        MerchantConstants.merchantId,
        context);
    debugPrint('html content is $htmlContent');

    if (htmlContent != null) {
      MaterialPageRoute route = MaterialPageRoute(
          builder: (BuildContext context) => MakePaymentWebViewScreen(
                makePaymentHtmlContent: htmlContent,
                webViewResponseUrl: widget.safeXPayBloc.successUrl,
              ));
      Navigator.pushReplacement(context, route);
    }
  }

  Widget getCardView(String asset, String bankName) {
    return Container(
        decoration: BoxDecoration(
          border: Border.all(
            color: Colors.grey,
            width: 1,
          ),
          borderRadius: BorderRadius.circular(8.0),
        ),
        padding: const EdgeInsets.all(8),
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            Image.asset(
              '$asset',
              height: (MediaQuery.of(context).size.width) / 5.8, //55,
              width: (MediaQuery.of(context).size.width) / 5.8, //55,
              // width: 55,
            ),
            SizedBox(height: 8),
            Text(
              '$bankName',
              style: const TextStyle(
                  color: Colors.grey,
                  fontStyle: FontStyle.normal,
                  fontSize: 14.0),
            ),
          ],
        ));
  }

  void _modalBottomSheetMenu() {
    showModalBottomSheet(
        isScrollControlled: true,
        context: context,
        builder: (builder) {
          return new Container(
            decoration: new BoxDecoration(
              color: Colors.transparent,
              borderRadius: new BorderRadius.only(
                topLeft: const Radius.circular(140.0),
                topRight: const Radius.circular(140.0),
              ),
            ),
            height: MediaQuery.of(context).size.height * 0.94,
            child: Center(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  Container(
                    color: Colors.white,
                    child: Container(
                      height: 50,
                      decoration: BoxDecoration(
                          color: Colors.grey[50],
                          borderRadius:
                              new BorderRadius.all(Radius.circular(5))),
                      padding: EdgeInsets.fromLTRB(5, 15, 5, 15),
                      margin: EdgeInsets.fromLTRB(20, 0, 20, 15),
                      child: Row(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: [
                          Container(
                              child: Expanded(
                                  flex: 1,
                                  child: TextFormField(
                                    autocorrect: false,
                                    decoration: new InputDecoration(
                                      border: InputBorder.none,
                                      hintText: "Search bank",
                                      prefixIcon: Icon(Icons.search,
                                          color: Colors.grey),
                                      focusedBorder: InputBorder.none,
                                      enabledBorder: InputBorder.none,
                                      errorBorder: InputBorder.none,
                                      disabledBorder: InputBorder.none,
                                      contentPadding: EdgeInsets.only(
                                          left: 10,
                                          bottom: 12,
                                          top: 0,
                                          right: 0),
                                    ),
                                    style: TextStyle(
                                        color: Colors.black.withOpacity(0.97),
                                        fontFamily: "Poppins",
                                        fontStyle: FontStyle.normal,
                                        fontSize: 14.0),
                                    // controller: editingController,
                                    onChanged: (value) {
                                      print("First text field: $value");
                                      _performSearch(value);
                                    },
                                  ))),
                        ],
                      ),
                    ),
                  ),
                  _buildBankNameListView(),
                ],
              ),
            ),
          );
        });
  }

  Widget _buildBankNameListView() {
    debugPrint('Filtered search list is ${_filterSearchList!.length}');
    return Expanded(
      child: ListView.separated(
        // shrinkWrap: true,
        separatorBuilder: (context, index) => Divider(
          color: Colors.grey[350],
          height: 0.8,
        ),
        padding: EdgeInsets.only(left: 8, right: 8),
        itemCount: _filterSearchList!.length,
        itemBuilder: (BuildContext ctxt, int index) {
          return _bankNameCell(_filterSearchList![index]);
        },
      ),
    );
  }

  Widget _bankNameCell(String _bankNameList) {
    return InkWell(
      onTap: () {
        setState(() {
          bankName = _bankNameList.toString();
        });
        Navigator.pop(context, false);
      },
      child: Padding(
          // height: 45,
          // alignment: Alignment.centerLeft,
          padding: EdgeInsets.all(12),
          child: Text(
            _bankNameList.toString(),
            style: const TextStyle(
                color: Colors.grey,
                fontStyle: FontStyle.normal,
                fontSize: 14.0),
          )),
    );
  }

  _performSearch(String _query) {
    _filterSearchList = <String>[];
    for (int i = 0; i < _bankNameList!.length; i++) {
      var item = _bankNameList![i];

      if (item.toLowerCase().contains(_query.toLowerCase())) {
        _filterSearchList!.add(item);
      }
    }
    setState(() {
      // _buildFilteredBankNameListView();
      _buildBankNameListView();
    });
  }

  Widget _buildFilteredBankNameListView() {
    return Container(
      child: Column(
        children: <Widget>[
          Container(
            height: 600,
            child: ListView.separated(
              separatorBuilder: (context, index) => Divider(
                color: Colors.grey[350],
                height: 0.8,
              ),
              padding: EdgeInsets.only(left: 8, right: 8),
              itemCount: _filterSearchList!.length,
              itemBuilder: (BuildContext ctxt, int index) {
                return _bankNameCell(_filterSearchList![index]);
              },
            ),
          )
        ],
      ),
    );
  }
}
